﻿# G DATA PRODUCT CLEANER #
G DATA Product Cleaner ist ein kostenfrei von der [G DATA CyberDefense AG](https://www.gdata.de) zur Verfügung gestelltes Tool, um die Reste einer G DATA Client Installation zu entfernen.

## Unterstützte Produkte ##

Der G DATA Product Cleaner kann die Reste folgender Produkte finden und entfernen:
- G DATA AntiVirus (Retail Produkt)
- G DATA Internet Security (Retail Produkt)
- G DATA Total Security (Retail Produkt)
- G DATA AntiVirus Client (Business Client)
- G DATA Endpoint Protection (Business Client)
- G DATA Management Server, G DATA Management Subnet Server
- G DATA for Exchange
- G DATA Bootmedium

## Installation und Ausführung ##

Der G DATA Product Cleaner ("Cleaner") kommt ohne Installation aus. Die ausführbare Datei kann auf der G DATA Webseite heruntergeladen und ausgeführt werden.

**Systemvoraussetzungen:**
* PC mit Intel oder AMD CPU mit SSE2-Unterstützung
* min. 1 GB RAM
* Windows 8, 8.1, 10, 11 (32 oder 64Bit), Windows Server ab Version 2016

*Hinweis:* Zur Ausführung werden Adminstratorrechte benötigt.

*Warnung:* Eine Ausführung während Windows Updates geladen oder installiert werden, ist nicht empfohlen. Der G DATA Product Cleaner zeigt in diesem Fall eine entsprechende Warnung an.

## Programmablauf ##

Im ersten Schritt wird nach Installationen oder übrig gebliebenen Daten gescannt und eine Zusammenfassung angezeigt. Falls die Installationsdateien für die Produkte noch vorhanden sind, kann der G DATA Product Cleaner die Produkte mittels des Installationsprogramms entfernen. In diesem Fall wird eine Übersicht der gefundenen Produkte angezeigt und die Methode zur Bereinigung kann gewählt werden. Der G DATA Product Cleaner kann auch die Funktion des Deinstallationsprogramms übernehmen.

Wenn G DATA-Dienste und Funktionen noch aktiv sind, ist nach der Bereinigung ein Neustart erforderlich. Der Cleaner setzt dann seine Arbeit nach dem Neustart fort und bereinigt die restlichen Daten.

Eine Liste aller noch verbleibenden Reste werden in einer CSV-Datei im %temp%-Verzeichnis des angemeldeten Benutzers abgelegt.

## Kommandozeile ##

Der G DATA Product Cleaner kann als normales Windows-Programm ausgeführt werden, aber er kann auch über die Kommandozeile verwendet werden. Für die Ausführung sind Administrator-Rechte erforderlich, das Programm zeigt eine Fehlermeldung an, wenn es von einer Kommandozeile mit eingeschränkten Rechten aufgerufen wird.

```
>GData_Product_Cleaner.exe
G DATA PRODUCT CLEANER v1.0
(C) G DATA CyberDefense AG, all rights reserved.
HINT: Use --help for command line options. Press CTRL-C to interrupt.

This program requires administrator rights!
```


Bei Aufruf mit dem Befehlszeilenargument --help wird eine Liste der unterstützten Parameter angezeigt.
```
>GData_Product_Cleaner.exe --help
G DATA Product Cleaner is a small tool to remove a G DATA product completely.
It can deinstall selected products and delete traces of old installations.

Command line switches:
--help | -h         Show help
--cleanall | -a     Remove all traces of any G DATA product. The cleaner chooses
                    the appropriate method to remove all traces. A reboot may be
                    necessary. This reboot will be executed automatically,
                    unless --noreboot is set.
                    THIS OPTION INVALIDATES ALL MODE SELECTIONS (see below).
--noreboot | -n     Don't reboot
--nomessage | -q    Quiet execution
--client:<MODE>     Select removal method for client installations, such as
                    G DATA Endpoint Protection, or the consumer products. 
--mms:<MODE>        Select removal method for the ManagementServer. 
--exchange:<MODE>   Select removal method for G DATA MailSecurity for Exchange.
--bootmedium:<MODE> Select removal method for the standalone BootMedium Creator.
--default:<MODE>    Select default removal method. If neither uninstall mode for
                    a given product is select, nor -default mode is set, the
                    product will not be removed.

Uninstall Modes:
keep | k            Don't remove the product
uninstall | u       Use setup to uninstall and clean the remains
clean | c           clean without invoking the setup

Exit Codes:
0                   Removal complete.
1                   Need reboot.
2                   Not all traces deleted.
3                   Insufficient rights. Restart as admin.
```

Ohne zusätzliche Parameter sucht der Cleaner nach vorhandenen Installationen oder Resten.
Falls Reste gefunden wurden, zeigt dies der Cleaner an. Die zusätzlichen Paramter steuern das Verhalten des Cleaners im Detail. 

*--help* oder *-h*:
Zeigt eine Kurzanleitung des Cleaners an.
 
 *--noreboot*:
 Ein evtl. notwendiger Reboot wird nicht ausgeführt.

 *--nomessage* oder *-q*:
 Der Cleaner gibt keine zusätzlichen Informationen aus (Quiet operation).

 *--cleanall* oder *-a*:
 Alles Reste werden entfernt. Der Cleaner fragt nicht nach, welche Daten auf welche Art entfernt werden sollen, sondern bereinigt das System von allen Spuren aller unterstützen Produkte. **Diese Einstellung macht alle folgenden Einstellungen ungültig! **

 **Produktauswahl**

 Falls mehr als ein Produkt das dazugehörige Installationsprogramm gefunden wurde, so zeigt dies der Cleaner an. Die Deinstallation dieser Produkte kann über die Kommandozeile gesteuert werden. Falls kein Deinstallationsmodus ausgewählt wurde, setzt der Cleaner als Vorauswahl "behalten" ("keep") ein. Die Vorauswahl kann mit dem Kommandozeilenparameter *--default:{Modus}* geändert werden. Die einzelnen Produkte werden durch diese Kommandozeilenparameter definiert:

*--client:{Modus}*:
Endpoint-Installationen, seien es die Privatkundenprodukte AntiVirus, InternetSecurity oder TotalSecurity, oder der Business-Endpoint.

*--mms:{Modus}*:
Business Management Server oder deren Subnetserver.

*--exchange:{Modus}*:
Antivirus for Exchange Produkts.

*--bootmedium:{Modus}*:
Bootmedium und Bootmedium-Wizard.

**Bereinigungsmodus**

Der {Modus} definiert die Bereinigunsmethode:

*keep* oder *k*: 
Die Installation wird behalten. Keine Änderung

*uninstall* oder *u*:
Zuerst wird die Deinstallation durch das Installationsprogramm durchgeführt, und danach mit dem Cleaner.

*cleaner* oder *c*:
Die Komponenten des Produktes werden nur mit dem Cleaner entfernt.

G DATA Produkte oder Komponenten, deren Installationsprogramm nicht mehr vorhanden ist, oder Installationsreste werden immer mit den eingebauten Regeln des Cleaners entfernt.

*Beispiele*

```GData_Product_Cleaner.exe --default:c --mms:u```
Entfernt den MMS mit dem Deinstallationsprogramm und den Rest mit dem Cleaner

```GData_Product_Cleaner.exe --mms:k --client:c```
Entfernt den Client mit dem Cleaner, und behält den MMS. Falls z.B. noch ein Bootmedium installiert ist, wird der Vorgang nicht ausgeführt.

```GData_Product_Cleaner.exe -a```
Entfernt alles

```GData_Product_Cleaner.exe -a --mms:keep```
Entfernt alles, der --mms:keep-Parameter wird ignoriert.

**Rückgabewert**

Der Cleaner gibt Informationen über den Reinigungsvorgang über den Rückgabewert des Programms zurück.
Die möglichen Rückgaberwerte sind:
0:                  Vorgang erfolgreich abgeschlossen
1:                  Ein Reboot ist nötig
2:                  Nicht alle Reste konnten entfernt werden
3:                  Unzureichende Berechtigungen. Bitte als Administrator starten.


## Mehrfache Ausführung ##

Es kann vorkommen, dass der Cleaner nicht alle Reste im ersten Durchlauf entfernen kann. In diesem Fall starten Sie den Rechner bitte neu und führen Sie den Cleaner danach noch einmal aus, um die letzten Reste zu entfernen.

## Lizenz und Haftungsausschluss ##
Die G DATA CyberDefense AG räumt dem Kunden eine nicht übertragbare Lizenz zur kostenfreien Nutzung dieses Programms ein. Die Lizenz umfasst den Download, Speicherung und die Ausführung dieses Programms auf einem oder mehreren Computern mit Windows Betriebssystem.
Das Reverse-Engineering, Dekompilieren, Abändern, Einbetten in andere Programme und andere Nutzungen, die der ursprünglichen Intention zuwider laufen, sind nicht erlaubt.
Das Programm wird von der G DATA CyberDefense AG kostenfrei zur Nutzung angeboten, es wird keine Haftung für durch die Nutzung dieser Software entstandenen Schäden (direkt, oder indirekt) übernommen. Die Nutzung des Programms erfolgt auf eigene Gefahr.

## Copyright ##
Dieses Programm unterliegt dem Copyright: (C) 2024 CyberDefense AG.
